package com.upay.sdk.declaration;


import com.alibaba.fastjson.JSONObject;
import com.upay.sdk.exception.HmacVerifyException;
import com.upay.sdk.exception.RequestException;
import com.upay.sdk.exception.ResponseException;
import com.upay.sdk.exception.UnknownException;
import com.upay.sdk.executer.ResultListenerAdpater;
import com.upay.sdk.serviceprovider.v3_0.report.builder.AliPayApiReportBuilder;
import com.upay.sdk.serviceprovider.v3_0.report.executer.AliPayApiReportExecuter;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 支付宝报备
 */
public class AliPayApiReportServlet extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {

        String partnerId = req.getParameter("partnerId");
        String merchantId = req.getParameter("merchantId");
        String requestId = req.getParameter("requestId");
        String channelType = req.getParameter("channelType");
        String distributorNo = req.getParameter("distributorNo");
        String merchantShortName = req.getParameter("merchantShortName");
        String name = req.getParameter("name");
        String idCardNo = req.getParameter("idCardNo");
        String mobile = req.getParameter("mobile");
        String email = req.getParameter("email");
        String tag = req.getParameter("tag");
        String type = req.getParameter("type");
        String servicePhone = req.getParameter("servicePhone");
        String indirectLevel = req.getParameter("indirectLevel");

        AliPayApiReportBuilder builder = new AliPayApiReportBuilder(merchantId)
                .setPartnerId(partnerId)
                .setRequestId(requestId)
                .setChannelType(channelType)
                .setDistributorNo(distributorNo)
                .setMerchantShortName(merchantShortName)
                .setName(name)
                .setIdCardNo(idCardNo)
                .setMobile(mobile)
                .setEmail(email)
                .setTag(tag)
                .setType(type)
                .setServicePhone(servicePhone)
                .setIndirectLevel(indirectLevel);

        final PrintWriter out = resp.getWriter();
        AliPayApiReportExecuter executer = new AliPayApiReportExecuter();

        try {

            executer.declare(builder, new ResultListenerAdpater() {
                @Override
                public void success(JSONObject jsonObject) {
                    out.println("处理成功！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void failure(JSONObject jsonObject) {
                    out.println("处理失败！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void pending(JSONObject jsonObject) {
                    out.println("待处理！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }
            });
        } catch (ResponseException e) {
            out.println("响应异常</br>");
            out.println(e.toString());
        } catch (HmacVerifyException e) {
            out.println("签名验证异常</br>");
            out.println(e.toString());
        } catch (RequestException e) {
            out.println("请求异常</br>");
            out.println(e.toString());
        } catch (UnknownException e) {
            out.println("未知异常</br>");
            out.println(e.toString());
        }
    }
}
