package com.upay.sdk.declaration;


import com.alibaba.fastjson.JSONObject;
import com.upay.sdk.exception.HmacVerifyException;
import com.upay.sdk.exception.RequestException;
import com.upay.sdk.exception.ResponseException;
import com.upay.sdk.exception.UnknownException;
import com.upay.sdk.executer.ResultListenerAdpater;
import com.upay.sdk.serviceprovider.v3_0.declaration.builder.BorrowReportBuilder;
import com.upay.sdk.serviceprovider.v3_0.declaration.executer.BorrowMerchantExecuter;
import com.upay.sdk.serviceprovider.v3_0.report.builder.CUPApiReportBuilder;
import com.upay.sdk.serviceprovider.v3_0.report.executer.CUPApiReportExecuter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;

/**
 * 二级商户银联报备接口
 */
public class BorrowReportServlet extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        String partnerId = req.getParameter("partnerId");
        String merchantId = req.getParameter("merchantId");
        String reportSerialNo = req.getParameter("reportSerialNo");
        String reportType = req.getParameter("reportType");

        BorrowReportBuilder builder = new BorrowReportBuilder();
        builder.setPartnerId(partnerId);
        builder.setMerchantId(merchantId);
        builder.setReportSerialNo(reportSerialNo);
        builder.setReportType(reportType);

        final PrintWriter out = resp.getWriter();

        BorrowMerchantExecuter executer = new BorrowMerchantExecuter();

        try {
            executer.bothOrder(builder, new ResultListenerAdpater() {
                @Override
                public void success(JSONObject jsonObject) {
                    out.println("处理成功！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void failure(JSONObject jsonObject) {
                    out.println("处理失败！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void pending(JSONObject jsonObject) {
                    out.println("待处理！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }
            });
        } catch (ResponseException e) {
            out.println("响应异常</br>");
            out.println(e.toString());
        } catch (HmacVerifyException e) {
            out.println("签名验证异常</br>");
            out.println(e.toString());
        } catch (RequestException e) {
            out.println("请求异常</br>");
            out.println(e.toString());
        } catch (UnknownException e) {
            out.println("未知异常</br>");
            out.println(e.toString());
        }
    }
}
