package com.upay.sdk.declaration;


import com.alibaba.fastjson.JSONObject;
import com.upay.sdk.exception.HmacVerifyException;
import com.upay.sdk.exception.RequestException;
import com.upay.sdk.exception.ResponseException;
import com.upay.sdk.exception.UnknownException;
import com.upay.sdk.executer.ResultListenerAdpater;
import com.upay.sdk.serviceprovider.v3_0.declaration.builder.QueryOpenAccountIntendConfirmApplyStatusBuilder;
import com.upay.sdk.serviceprovider.v3_0.declaration.executer.QueryOpenAccountIntendConfirmApplyStatusExecuter;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 愿核实查询接口
 */
public class QueryApplyStatusServlet extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {

        String partnerId = req.getParameter("partnerId");
        String merchantId = req.getParameter("merchantId");
        String applyRequestId = req.getParameter("applyRequestId");
        String channelType = req.getParameter("channelType");

        QueryOpenAccountIntendConfirmApplyStatusBuilder builder = new QueryOpenAccountIntendConfirmApplyStatusBuilder(merchantId);
        builder.setPartnerId(partnerId);
        builder.setApplyRequestId(applyRequestId);
        builder.setChannelType(channelType);

        final PrintWriter out = resp.getWriter();
        QueryOpenAccountIntendConfirmApplyStatusExecuter executer = new QueryOpenAccountIntendConfirmApplyStatusExecuter();

        try {

            executer.declare(builder, new ResultListenerAdpater() {
                @Override
                public void success(JSONObject jsonObject) {
                    out.println("处理成功！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void failure(JSONObject jsonObject) {
                    out.println("处理失败！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }
            });
        } catch (ResponseException e) {
            out.println("响应异常</br>");
            out.println(e.toString());
        } catch (HmacVerifyException e) {
            out.println("签名验证异常</br>");
            out.println(e.toString());
        } catch (RequestException e) {
            out.println("请求异常</br>");
            out.println(e.toString());
        } catch (UnknownException e) {
            out.println("未知异常</br>");
            out.println(e.toString());
        }
    }
}
