package com.upay.sdk.declaration;


import com.alibaba.fastjson.JSONObject;
import com.upay.sdk.exception.HmacVerifyException;
import com.upay.sdk.exception.RequestException;
import com.upay.sdk.exception.ResponseException;
import com.upay.sdk.exception.UnknownException;
import com.upay.sdk.executer.ResultListenerAdpater;
import com.upay.sdk.serviceprovider.v3_0.declaration.builder.QuerySuccessSecondaryReportBuilder;
import com.upay.sdk.serviceprovider.v3_0.declaration.executer.QuerySuccessSecondaryReportExecuter;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 报备记录查询
 */
public class QuerySuccessReportServlet extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {

        String merchantId = req.getParameter("merchantId");
        String partnerId = req.getParameter("partnerId");

        String requestId = req.getParameter("requestId");

        QuerySuccessSecondaryReportBuilder builder = new QuerySuccessSecondaryReportBuilder();
        builder.setMerchantId(merchantId);
        builder.setPartnerId(partnerId);
        builder.setRequestId(requestId);

        final PrintWriter out = resp.getWriter();
        QuerySuccessSecondaryReportExecuter executer = new QuerySuccessSecondaryReportExecuter();

        try {

            executer.query(builder, new ResultListenerAdpater() {
                @Override
                public void success(JSONObject jsonObject) {
                    out.println("处理成功！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void failure(JSONObject jsonObject) {
                    out.println("处理失败！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }
            });
        } catch (ResponseException e) {
            out.println("响应异常</br>");
            out.println(e.toString());
        } catch (HmacVerifyException e) {
            out.println("签名验证异常</br>");
            out.println(e.toString());
        } catch (RequestException e) {
            out.println("请求异常</br>");
            out.println(e.toString());
        } catch (UnknownException e) {
            out.println("未知异常</br>");
            out.println(e.toString());
        }
    }
}
