package com.upay.sdk.declaration;

import com.alibaba.fastjson.JSONObject;
import com.upay.sdk.exception.HmacVerifyException;
import com.upay.sdk.exception.RequestException;
import com.upay.sdk.exception.ResponseException;
import com.upay.sdk.exception.UnknownException;
import com.upay.sdk.executer.ResultListenerAdpater;
import com.upay.sdk.serviceprovider.v3_0.declaration.builder.OpenAccountIntendConfirmApplyBuilder;
import com.upay.sdk.serviceprovider.v3_0.declaration.executer.OpenAccountIntendConfirmApplyExecuter;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 意愿核查提交接口
 */
public class SubmitApplyServlet extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {

        String channelType = req.getParameter("channelType");
        String partnerId = req.getParameter("partnerId");
        String merchantId = req.getParameter("merchantId");
        String requestId = req.getParameter("requestId");
        String reportRequestId = req.getParameter("reportRequestId");
        String applyTimeout = req.getParameter("applyTimeout");
        String notifyUrl = req.getParameter("notifyUrl");
        String name = req.getParameter("name");
        String mobile = req.getParameter("mobile");
        String idCardNumber = req.getParameter("idCardNumber");
        String microBizType = req.getParameter("microBizType");
        String storeName = req.getParameter("storeName");
        String storeHeaderCopy = req.getParameter("storeHeaderCopy");
        String storeIndoorCopy = req.getParameter("storeIndoorCopy");

        OpenAccountIntendConfirmApplyBuilder builder = new OpenAccountIntendConfirmApplyBuilder(merchantId);
        builder.setPartnerId(partnerId);
        builder.setRequestId(requestId);
        builder.setReportRequestId(reportRequestId);
        builder.setApplyTimeout(applyTimeout);
        builder.setNotifyUrl(notifyUrl);
        builder.setName(name);
        builder.setMobile(mobile);
        builder.setIdCardNumber(idCardNumber);
        builder.setMicroBizType(microBizType);
        builder.setStoreName(storeName);
        builder.setStoreHeaderCopy(storeHeaderCopy);
        builder.setStoreIndoorCopy(storeIndoorCopy);
        builder.setChannelType(channelType);

        final PrintWriter out = resp.getWriter();
        OpenAccountIntendConfirmApplyExecuter executer = new OpenAccountIntendConfirmApplyExecuter();

        try {

            executer.declare(builder, new ResultListenerAdpater() {
                @Override
                public void success(JSONObject jsonObject) {
                    out.println("处理成功！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void failure(JSONObject jsonObject) {
                    out.println("处理失败！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void pending(JSONObject jsonObject) {
                    out.println("待处理！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }
            });
        } catch (ResponseException e) {
            out.println("响应异常</br>");
            out.println(e.toString());
        } catch (HmacVerifyException e) {
            out.println("签名验证异常</br>");
            out.println(e.toString());
        } catch (RequestException e) {
            out.println("请求异常</br>");
            out.println(e.toString());
        } catch (UnknownException e) {
            out.println("未知异常</br>");
            out.println(e.toString());
        }
    }
}
