package com.upay.sdk.declaration;

import com.alibaba.fastjson.JSONObject;
import com.upay.sdk.exception.HmacVerifyException;
import com.upay.sdk.exception.RequestException;
import com.upay.sdk.exception.ResponseException;
import com.upay.sdk.exception.UnknownException;
import com.upay.sdk.executer.ResultListenerAdpater;
import com.upay.sdk.serviceprovider.v3_0.report.builder.WeChatApiReportBuilder;
import com.upay.sdk.serviceprovider.v3_0.report.executer.WechatApiReportExecuter;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 商户微信报备
 */
public class WeChatApiReportServlet extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {

        String partnerId = req.getParameter("partnerId");
        String merchantId = req.getParameter("merchantId");
        String requestId = req.getParameter("requestId");
//        String channelType = req.getParameter("channelType");
        String mcc = req.getParameter("mcc");
        String distributorNo = req.getParameter("distributorNo");
        String merchantShortName = req.getParameter("merchantShortName");
        String servicePhone = req.getParameter("servicePhone");
        String contact = req.getParameter("contact");
        String contactPhone = req.getParameter("contactPhone");
        String contactEmail = req.getParameter("contactEmail");
        String merchantRemark = req.getParameter("merchantRemark");

        WeChatApiReportBuilder builder = new WeChatApiReportBuilder(merchantId);
        builder.setPartnerId(partnerId);
        builder.setRequestId(requestId);
//        builder.setChannelType(channelType);
        builder.setDistributorNo(distributorNo);
        builder.setMerchantShortName(merchantShortName);
        builder.setServicePhone(servicePhone);
        builder.setContact(contact);
        builder.setContactPhone(contactPhone);
        builder.setContactEmail(contactEmail);
        builder.setMerchantRemark(merchantRemark);
        builder.setMcc(mcc);

        final PrintWriter out = resp.getWriter();
        WechatApiReportExecuter executer = new WechatApiReportExecuter();

        try {

            executer.declare(builder, new ResultListenerAdpater() {
                @Override
                public void success(JSONObject jsonObject) {
                    out.println("处理成功！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void failure(JSONObject jsonObject) {
                    out.println("处理失败！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void pending(JSONObject jsonObject) {
                    out.println("待处理！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }
            });
        } catch (ResponseException e) {
            out.println("响应异常</br>");
            out.println(e.toString());
        } catch (HmacVerifyException e) {
            out.println("签名验证异常</br>");
            out.println(e.toString());
        } catch (RequestException e) {
            out.println("请求异常</br>");
            out.println(e.toString());
        } catch (UnknownException e) {
            out.println("未知异常</br>");
            out.println(e.toString());
        }
    }
}
