package com.upay.sdk.declaration;

import com.alibaba.fastjson.JSONObject;
import com.upay.sdk.exception.HmacVerifyException;
import com.upay.sdk.exception.RequestException;
import com.upay.sdk.exception.ResponseException;
import com.upay.sdk.exception.UnknownException;
import com.upay.sdk.executer.ResultListenerAdpater;
import com.upay.sdk.serviceprovider.v3_0.report.builder.WeChatConfigReportBuilder;
import com.upay.sdk.serviceprovider.v3_0.report.executer.WeChatConfigReportExecuter;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 微信支付配置
 */
public class WeChatConfigReportServlet extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {

        String partnerId = req.getParameter("partnerId");
        String merchantId = req.getParameter("merchantId");
        String requestId = req.getParameter("requestId");
        String reportRequestId = req.getParameter("reportRequestId");
        String configType = req.getParameter("configType");
        String configInfo = req.getParameter("configInfo");
        String appType = req.getParameter("appType");

        WeChatConfigReportBuilder builder = new WeChatConfigReportBuilder(merchantId);
        builder.setPartnerId(partnerId).setRequestId(requestId)
                .setReportRequestId(reportRequestId).setConfigType(configType)
                .setConfigInfo(configInfo).setAppType(appType);

        final PrintWriter out = resp.getWriter();

        WeChatConfigReportExecuter executer = new WeChatConfigReportExecuter();

        try {

            executer.declare(builder, new ResultListenerAdpater() {
                @Override
                public void success(JSONObject jsonObject) {
                    out.println("处理成功！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void failure(JSONObject jsonObject) {
                    out.println("处理失败！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }

                @Override
                public void pending(JSONObject jsonObject) {
                    out.println("待处理！<br/>");
                    String result = jsonObject.toJSONString();
                    out.print(result);
                }
            });
        } catch (ResponseException e) {
            out.println("响应异常</br>");
            out.println(e.toString());
        } catch (HmacVerifyException e) {
            out.println("签名验证异常</br>");
            out.println(e.toString());
        } catch (RequestException e) {
            out.println("请求异常</br>");
            out.println(e.toString());
        } catch (UnknownException e) {
            out.println("未知异常</br>");
            out.println(e.toString());
        }
    }
}
